<?php

function getWhitelistedNames() {
	return array_merge(

		// Functions
		get_defined_functions()['internal'],
		
		// Superglobals
		[
			'GLOBALS', '_SERVER', '_GET', '_POST', '_FILES', '_COOKIE', '_SESSION', '_REQUEST', '_ENV'
		],
		
		// Constants
		array_keys(get_defined_constants(false)),
		
		// Engine constants
		[
			'true', 'True', 'TRUE', // nonexhaustive :/
			'false', 'False', 'FALSE',
			'null', 'Null', 'NULL',
		],
		
		// Magic constants
		[
			'__CLASS__', '__DIR__', '__FILE__', '__FUNCTION__',
			'__LINE__', '__METHOD__', '__NAMESPACE__', '__TRAIT__',
		],
		
		// Classes
		get_declared_classes(),
		
		// Interfaces
		get_declared_interfaces(),
		
		// Traits
		get_declared_traits(),
		
		// Reserved words
		[
			'__halt_compiler',
			'abstract',
			'and',
			'array',
			'as',
			'break',
			'callable',
			'case',
			'catch',
			'class',
			'clone',
			'const',
			'continue',
			'declare',
			'default',
			'die',
			'do',
			'echo',
			'else',
			'elseif',
			'empty',
			'enddeclare',
			'endfor',
			'endforeach',
			'endif',
			'endswitch',
			'endwhile',
			'eval',
			'exit',
			'extends',
			'final',
			'finally',
			'for',
			'foreach',
			'function',
			'global',
			'goto',
			'if',
			'implements',
			'include',
			'include_once',
			'instanceof',
			'insteadof',
			'interface',
			'isset',
			'list',
			'namespace',
			'new',
			'or',
			'print',
			'private',
			'protected',
			'public',
			'require',
			'require_once',
			'return',
			'static',
			'switch',
			'throw',
			'trait',
			'try',
			'unset',
			'use',
			'var',
			'while',
			'xor',
			'yield',	
		],
		
		// Words that have special meaning in certain contexts
		[ 'this', 'self', 'class', 'parent', 'static' ],
		
		// Special words that are likely to cause problems
		[
			'autoload',   // SPL autoload_register
			
			// Standard classes
			'current', 'key', 'next', 'rewind', 'valid', // Iterator interface
			'getIterator', // IteratorAggregate interface
			'offsetExists', 'offsetGet', 'offsetSet', 'offsetUnset', // ArrayAccess interface
			'bind', 'bindTo', // Closure interface
			'send', 'throw', // Generator class
			
			// Keys in $_SERVER
			'PHP_SELF', 'argv', 'argc', 'GATEWAY_INTERFACE', 'SERVER_ADDR',
			'SERVER_NAME', 'SERVER_SOFTWARE', 'SERVER_PROTOCOL',
			'REQUEST_METHOD', 'REQUEST_TIME', 'REQUEST_TIME_FLOAT',
			'QUERY_STRING', 'DOCUMENT_ROOT', 'HTTP_ACCEPT', 'HTTP_ACCEPT_CHARSET',
			'HTTP_ACCEPT_ENCODING', 'HTTP_ACCEPT_LANGUAGE', 'HTTP_CONNECTION',
			'HTTP_HOST', 'HTTP_REFERER', 'HTTP_USER_AGENT', 'HTTPS',
			'REMOTE_ADDR', 'REMOTE_HOST', 'REMOTE_PORT', 'REMOTE_USER',
			'REDIRECT_REMOTE_USER', 'SCRIPT_FILENAME', 'SERVER_ADMIN',
			'SERVER_PORT', 'SERVER_SIGNATURE', 'PATH_TRANSLATED', 
			'SCRIPT_NAME', 'REQUEST_URI', 'PHP_AUTH_DIGEST', 'PHP_AUTH_USER',
			'PHP_AUTH_PW', 'AUTH_TYPE', 'PATH_INFO', 'ORIG_PATH_INFO',
			
			// Keys in error_get_last
			'type', 'message', 'file', 'line',
		],
		
		// Magic method names
		[
			'__construct', '__destruct', '__call', '_callStatic',
			'__get', '__set', '__isset', '__unset', '__sleep',
			'__wakeup', '__toString', '__invoke', '__set_state',
			'__clone', '__debuginfo'
		]
	);
}
