#!/bin/bash

PHP=/cygdrive/c/bin/php54/php.exe

pack() {
	STASH=$(mktemp)
	cat > $STASH
	STASH_W=$(cygpath -w "$STASH")
	$PHP phppack.php --no-pack "$STASH_W"
	rm $STASH
}


DIR=$(mktemp -d)

cat <<'EOF' > $DIR/a.php
<?php

echo "in a.php\n";
echo "__DIR__:  ".__DIR__."\n";
echo "__FILE__: ".__FILE__."\n";

require "b.php";
// require __DIR__."/b.php";

EOF

cat <<'EOF' > $DIR/b.php
<?php

echo "in b.php\n";

EOF

mkdir -p tmp-tests
OUTPUT=tmp-tests/$(date +%s)-packtest.php

$PHP phppack.php --no-obfuscate "$(cygpath -w $DIR/a.php)" "$(cygpath -w $DIR/b.php)" > $OUTPUT

rm $DIR/a.php
rm $DIR/b.php
rmdir $DIR

$PHP "$(cygpath -w "$OUTPUT")"

read -p "Press any key to continue..."
